
var constantAutoModeManualOff = 0;
var constantAutoModeOnlyHoliday = 1;
var constantAutoModeOnGehen = 2;
var constantAutoModeManualOn = 3;

var constantEmailOff = 0;
var constantEmailOn = 1;

var constantSendEmailHolidayStart = 0;
var constantSendEmailHolidayEnd = 1;
var constantSendEmailGehen = 2;
var constantSendEmailKommen = 3;
var constantSendEmailManualOn = 4;
var constantSendEmailManualOff = 5;
var constantSendEmailUnspecOn = 6;
var constantSendEmailUnspecOff = 7;
var constantSendEmailStartingUp = -1;

var emailBodyHolydayStart = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil der Urlaub <NameOfHoliday> nun beginnt.';
var subjectHolydayStart = "Anwesenheitsimulation eingeschaltet";
var emailBodyHolydayEnd = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil der Urlaub <NameOfHoliday> nun endet.';
var subjectHolydayEnd = "Anwesenheitsimulation ausgeschaltet";

var emailBodyGehen = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil die Aktion "Gehen" ausgeloest wurde.';
var subjectBodyGehen = "Anwesenheitsimulation eingeschaltet";
var emailBodyKommen = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil die Aktion "Kommen" ausgeloest worden ist.';
var subjectBodyKommen = "Anwesenheitsimulation ausgeschaltet";

var emailBodyManualOn = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil sie manuell eingeschaltet wurde.';
var subjectBodyManualOn = "Anwesenheitsimulation eingeschaltet";
var emailBodyManualOff = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil sie manuell abgeschaltet wurde.';
var subjectBodyManualOff = "Anwesenheitsimulation ausgeschaltet";

var emailBodyOn = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet.';
var subjectBodyOn = "Anwesenheitsimulation eingeschaltet";
var emailBodyOff = 'Die Anwesenheitssimulation wurde um <timestamp> beendet.';
var subjectBodyOff = "Anwesenheitsimulation ausgeschaltet";


function timeStamp() {
    var oDate = new Date();
    return oDate.getDate() + "." + (oDate.getMonth() + 1) + "." + oDate.getFullYear() + " " + pad(oDate.getHours()) + ":" + pad(oDate.getMinutes());
}

function sendEmail(fEmailType, sHoliday) {
    Property.load();
    if (Property.getNode(propertyPathForPS+'general/emailMode')==null) {
        lInfo.logln('No Email should be send');
        return;
    }
    if (Property.getNode(propertyPathForPS+'general/emailMode').getValue()==null) {
        lInfo.logln('No Email should be send');
        return;
    }
     
    if (Property.getNode(propertyPathForPS+'general/emailMode').getValue() != 1) {
        lInfo.logln('No Email should be send');
        return;
    }
    var oDate = new Date();
    var to = Property.getNode(propertyPathForPS + 'general/emailReceiver');
    if (to == null) {
        lWarn.logln("sendEmail: kein Empfnger konfiguriert");
        return;
    }
    if (fEmailType == constantSendEmailStartingUp) {
        lWarn.logln("sendEmail: restore on Restart -> no Email !");
        return;
    }
    var body = "";
    var subject = "";
    switch (fEmailType) {
        case 0: // constantSendEmailHolidayStart
            body = emailBodyHolydayStart;
            subject = subjectHolydayStart;
        break;
        case 1: // constantSendEmailHolidayEnd
            body = emailBodyHolydayEnd;
            subject = subjectHolydayEnd;
        break;
        case 2: // constantSendEmailGehen
            body = emailBodyGehen;
            subject = subjectBodyGehen;
        break;
        case 3: // constantSendEmailKommen
            body = emailBodyKommen;
            subject = subjectBodyKommen;
        break;
        case 4: // constantSendEmailManualOn
            body = emailBodyManualOn;
            subject = subjectBodyManualOn;
        break;
        case 5: // constantSendEmailManualOff
            body = emailBodyManualOff;
            subject = subjectBodyManualOff;
        break;
        case 6: // constantSendEmailUnspecOn
            body = emailBodyOn;
            subject = subjectBodyOn;
        break;
        case 7: // constantSendEmailUnspecOff
            body = emailBodyOff;
            subject = subjectBodyOff;
        break;

    }


    lWarn.logln("prepareSendEmail: sende Email an: " + to.getValue() + " Subject: " + subject + " Body: " + body);

    prepareAndSendMail(body,subject,'dSS-Anwesenheitsimulation',to.getValue(),sHoliday);
    
    /*var evt = new Event("system-addon-presence-simulator-mail", {
        'to' : to.getValue(),
        'body' : body,
        'subject' : subject,
        'from' : 'dSS-Anwesenheitsimulation'
    });
    evt.raise();*/
}

function pad(c) {
    var i = parseInt(c, 10);
    return (i < 10 ? '0' + i : c.toString());
}

function scheduleHolidayCheck() {
    lInfo.logln('scheduleHolidayCheck');
    
      
    var aOldNotes = Property.getNode('dynamic/holidaycheck');
    if (aOldNotes != null) {
        lInfo.logln('scheduleHolidayCheck - remove old');
        var queue = aOldNotes.getChildren();

        for ( var i = 0; i < queue.length; ++i) {
            var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
            if (propNode) {
                propNode.getParent().removeChild(propNode);
            }
            lInfo.logln('scheduleHolidayCheck - remove old #' + i);
        }
    }
    var aOldNotes = Property.getNode('dynamic');
    if (aOldNotes != null)
        aOldNotes.removeChild('holidaycheck');

    lInfo.logln('scheduleHolidayCheck - adding');
    var sRRule = "FREQ=DAILY;COUNT=1";
    var holidayBase = Property.getNode('values/holiday');
    if (holidayBase == null)
        return;
    var holidayNodes = holidayBase.getChildren();
    for ( var iIndex = 0; iIndex < holidayNodes.length; iIndex++) {

        try {
                // holiday start
            var iVon = parseInt(holidayNodes[iIndex].getChild('von').getValue(), 10);
            var d = new Date();
            d.setTime(iVon * 1000);
            var iCalStartTime = d.getFullYear() + pad(d.getMonth() + 1) + pad(d.getDate()) + 'T' + pad(d.getHours()) + pad(d.getMinutes())
                    + pad(d.getSeconds());
            var oParameter = {
                iCalRRule : sRRule,
                iCalStartTTime : iCalStartTime,
                actions : 'checkHoliday'
            };
            var timerEvent = new TimedICalEvent('system-addon-presence-simulator', iCalStartTime, sRRule, {
                actions : 'checkHoliday'
            });
            lInfo.logln('recheck holiday (Start #'+ iIndex +'): - ' + iCalStartTime);
            Property.setProperty('dynamic/holidaycheck/' + iIndex + '_von', timerEvent.raise());
    
            // holiday ende
            var iBis = parseInt(holidayNodes[iIndex].getChild('bis').getValue(), 10);
            d.setTime(iBis * 1000);
            iCalStartTime = d.getFullYear() + pad(d.getMonth() + 1) + pad(d.getDate()) + 'T' + pad(d.getHours()) + pad(d.getMinutes())
                    + pad(d.getSeconds());
    
            oParameter = {
                iCalRRule : sRRule,
                iCalStartTTime : iCalStartTime,
                actions : 'checkHoliday'
            };
    
            timerEvent = new TimedICalEvent('system-addon-presence-simulator', iCalStartTime, sRRule, {
                actions : 'checkHoliday'
            });
    
            lInfo.logln('recheck holiday (End #'+ iIndex +'): - ' + iCalStartTime);
    
            Property.setProperty('dynamic/holidaycheck/' + iIndex + '_bis', timerEvent.raise());
        } catch (e) {
            lWarn.logln("Fehler beim scheduleHolidayCheck: " + e);
            for ( var i in e) {
                l.logln(i + ': ' + e[i]);
            }
        }        
    }
}

function setStateHoliday(fOn) {
    var pNode = Property.getNode('/usr/states/holiday');
    if (fOn) {
        lInfo.logln('set State to ON!');
        pNode.setStatusValue("on");
    } else {
        lInfo.logln('set State to OFF!');
        pNode.setStatusValue("off");
    }
}

function setPresenceState(fOn, emailType, sHoliday) {
    lWarn.logln("setPresenceState " + fOn + " emailtype: " + emailType + " sHoliday: " + sHoliday);
    var activeProperty = Property.getNode('/usr/states/holiday/value');
    if (activeProperty) {
        var sStateValue=activeProperty.getValue();
        lInfo.logln('State is set to ' + activeProperty.getValue() + " and will be set to " + (fOn ? 'on':'off'));
        if (activeProperty.getValue() == (fOn ? 'on':'off')) {
            lInfo.logln('State is allready set to ' + activeProperty.getValue() + ' so no action should be done');
            return;
        }
    }
    if (fOn) {
        sendEmail(emailType, sHoliday);
        setStateHoliday(true);
    } else {
        sendEmail(emailType, sHoliday);
        setStateHoliday(false);
    }
}

function getPresenceState() {
    var pNode = Property.getNode('/usr/states/holiday/value');
    return (pNode.getValue()=='on');
}

function getGehenState() {
    var pNode = Property.getNode('/usr/states/presence/value');
    return (pNode.getValue()=='absent');
}

function checkNow(iCheckScene) {
    var autoMode = Property.getNode('general/autoMode');
    if (autoMode != null) {
        if (autoMode.getValue() == constantAutoModeManualOff) {
            setPresenceState(false,constantSendEmailManualOff,"");
            return;
        }
        if (autoMode.getValue() == constantAutoModeManualOn) {
            setPresenceState(true,constantSendEmailManualOn,"");
            return;
        }
    }
    
    var fActive = false;
    
    
    var iEmailType = constantSendEmailHolidayEnd;
    if (iCheckScene != null)
        iEmailType = iCheckScene;
    var sHolidayName = "";
    var holidayBase = Property.getNode('values/holiday');
    if (holidayBase != null) {
        var holidayNodes = holidayBase.getChildren();
        var lNow = Math.floor(((new Date()).getTime()) / 1000);
        lInfo.logln("lNow " + lNow);
        for ( var iIndex = 0; iIndex < holidayNodes.length; iIndex++) {
            var iVon = parseInt(holidayNodes[iIndex].getChild('von').getValue(), 10);
            var iBis = parseInt(holidayNodes[iIndex].getChild('bis').getValue(), 10);
            if (iVon <= lNow) {
                if (lNow < iBis) {
                    fActive = true;
                    iEmailType = constantSendEmailHolidayStart;
                    sHolidayName = holidayNodes[iIndex].getChild('name').getValue();
                    lInfo.logln("Holiday " + sHolidayName + " is now in Effect!");
                }
            }
        }
    }
    if (!fActive) {
        //urlaub vorbei, aber Gehen-State kann noch aktiv sein
        if (autoMode != null)
            if (autoMode.getValue() == constantAutoModeOnGehen) 
                if (getGehenState()) {
                        fActive=true;
                    }
    } else {
        // Urlaub nicht vorbei
    }
    
    setPresenceState(fActive, iEmailType, sHolidayName);
}

function checkScene() {
    var zone = raisedEvent.parameter.zoneID;
    var group = raisedEvent.parameter.groupID;
    var scene = raisedEvent.parameter.sceneID;
    lWarn.logln('callScene!!! ' + zone + '|'+ group + '|'+ scene + '|');
    
    if (zone == null)
        return;
    if (group == null)
        return;
    if (scene == null)
        return;
    var iAction = -1;
    if (zone == 0) {
        if (group == 0) {
            if (scene == 72) // gehen aktiv
            {
                iAction = 0;
            } else if (scene == 71) // kommen aktiv
            {
                iAction = 1;
            }
        }
    }

    var autoMode = Property.getNode('general/autoMode');
    if (autoMode == null)
        return;
    if (autoMode.getValue() != constantAutoModeOnGehen)
        return;
    if (iAction == -1)
        return;
    if (iAction == 0) {
        setPresenceState(true, constantSendEmailGehen);
    }
    if (iAction == 1) {
        checkNow(constantSendEmailKommen);
    }

    return;
}



if (raisedEvent.name == 'system-addon-presence-simulator') {
    Property.load();
    if (raisedEvent.parameter.actions!=null) {
        lInfo.logln('Action is ' + raisedEvent.parameter.actions);
        if (raisedEvent.parameter.actions == 'starting') {            
        }
        if (raisedEvent.parameter.actions == 'setMode') {
            if (raisedEvent.parameter.value!=null) {
                if ((parseInt(raisedEvent.parameter.value,10))<5) {
                    Property.setProperty('general/autoMode', (parseInt(raisedEvent.parameter.value,10)));
                    Property.setFlag('general/autoMode', 'ARCHIVE', true);
                    Property.store();
                }
            }
            checkNow();
        }
        if (raisedEvent.parameter.actions == 'setEmail') {
            if (raisedEvent.parameter.enabled!=null) {
                Property.setProperty('general/emailMode', (parseInt(raisedEvent.parameter.enabled,10)));
                Property.setFlag('general/emailMode', 'ARCHIVE', true);
            }
            if (raisedEvent.parameter.receiver!=null) {
                Property.setProperty('general/emailReceiver', unescape(raisedEvent.parameter.receiver));
                Property.setFlag('general/emailReceiver', 'ARCHIVE', true);
            }
            Property.store();
        }
        if (raisedEvent.parameter.actions == 'checkDate') {
            checkNow();
        }
        if (raisedEvent.parameter.actions == 'checkHoliday') {
            checkNow();
            scheduleHolidayCheck();
        }
    }
}

if (raisedEvent.name == 'system-addon-presence-simulator.callScene') {
	try {
		checkScene();
	} catch (e) {
		lWarn.logln(e);
	}
}